/* (c) https://github.com/MontiCore/monticore */
#ifndef TEST_PACMANSAMPLEGAME_MAIN_GHOST4WORLDMANAGER_PACMANWORLDHANDLER_MOVEMENTHANDLER_PACMANMOVEMENTCOLLISIONCHECKER
#define TEST_PACMANSAMPLEGAME_MAIN_GHOST4WORLDMANAGER_PACMANWORLDHANDLER_MOVEMENTHANDLER_PACMANMOVEMENTCOLLISIONCHECKER
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif
#include <cstdlib>
#include "armadillo.h"
#include "test_pacmanSampleGame_main_ghost4WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker_collisionCalculator.h"
#include "test_pacmanSampleGame_main_ghost4WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker_collisionCalculatorLastDirection.h"
#include "test_pacmanSampleGame_main_ghost4WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker_decider.h"
using namespace arma;
class test_pacmanSampleGame_main_ghost4WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker{
const int tilesMaxX = 17;
const int tilesMaxY = 17;
const int tileSize = 16;
public:
bool moveUp;
bool moveDown;
bool moveLeft;
bool moveRight;
bool moveUpLastDirection;
bool moveDownLastDirection;
bool moveLeftLastDirection;
bool moveRightLastDirection;
imat world;
int pacmanPositionX;
int pacmanPositionY;
int pacmanPossibleNextPositionX;
int pacmanPossibleNextPositionY;
int pacmanPossibleNextPositionXLastDirection;
int pacmanPossibleNextPositionYLastDirection;
bool canMove;
bool canMoveLastDirection;
int pacmanChosenNextPositionX;
int pacmanChosenNextPositionY;
test_pacmanSampleGame_main_ghost4WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker_collisionCalculator collisionCalculator;
test_pacmanSampleGame_main_ghost4WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker_collisionCalculatorLastDirection collisionCalculatorLastDirection;
test_pacmanSampleGame_main_ghost4WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker_decider decider;
void init()
{
world=imat(tilesMaxX,tilesMaxY);
collisionCalculator.init();
collisionCalculatorLastDirection.init();
decider.init();
}
void execute()
{
collisionCalculator.moveUp = moveUp;
collisionCalculator.moveDown = moveDown;
collisionCalculator.moveLeft = moveLeft;
collisionCalculator.moveRight = moveRight;
collisionCalculator.world = world;
collisionCalculator.pacmanPositionX = pacmanPositionX;
collisionCalculator.pacmanPositionY = pacmanPositionY;
collisionCalculator.pacmanPossibleNextPositionX = pacmanPossibleNextPositionX;
collisionCalculator.pacmanPossibleNextPositionY = pacmanPossibleNextPositionY;
collisionCalculatorLastDirection.moveUp = moveUpLastDirection;
collisionCalculatorLastDirection.moveDown = moveDownLastDirection;
collisionCalculatorLastDirection.moveLeft = moveLeftLastDirection;
collisionCalculatorLastDirection.moveRight = moveRightLastDirection;
collisionCalculatorLastDirection.world = world;
collisionCalculatorLastDirection.pacmanPositionX = pacmanPositionX;
collisionCalculatorLastDirection.pacmanPositionY = pacmanPositionY;
collisionCalculatorLastDirection.pacmanPossibleNextPositionX = pacmanPossibleNextPositionXLastDirection;
collisionCalculatorLastDirection.pacmanPossibleNextPositionY = pacmanPossibleNextPositionYLastDirection;
collisionCalculatorLastDirection.execute();
collisionCalculator.execute();
decider.canMove = collisionCalculator.canMove;
decider.pacmanChosenNextPositionXCurrentDirection = collisionCalculator.pacmanChosenNextPositionX;
decider.pacmanChosenNextPositionYCurrentDirection = collisionCalculator.pacmanChosenNextPositionY;
decider.canMoveLastDirection = collisionCalculatorLastDirection.canMove;
decider.pacmanChosenNextPositionXLastDirection = collisionCalculatorLastDirection.pacmanChosenNextPositionX;
decider.pacmanChosenNextPositionYLastDirection = collisionCalculatorLastDirection.pacmanChosenNextPositionY;
decider.execute();
canMove = collisionCalculator.canMove;
canMoveLastDirection = collisionCalculatorLastDirection.canMove;
pacmanChosenNextPositionX = decider.pacmanChosenNextPositionX;
pacmanChosenNextPositionY = decider.pacmanChosenNextPositionY;
}

};
#endif
